/*
 * Created by SharpDevelop.
 * User: Stephen
 * Date: 7/31/2007
 * Time: 12:56 PM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Xml.Serialization;
using System.Runtime.Serialization.Formatters.Soap;

namespace MgmtWithWMI
{
	class MainClass
	{
		public static void Main(string[] args)
		{
			WMI1 netIfs = 
				new WMI1();
			Console.WriteLine("Hello World!");
			Console.WriteLine(netIfs.getNetworkInterfaceDetails());
			Console.WriteLine(netIfs.getIPRouteTable());
			
			#region XmlSeralizer
            // Save object to a file named WMI1.xml in XML format.
            XmlSerializer xmlFormat = new XmlSerializer(typeof(WMI1));

            Stream fStream = new FileStream("wmi.xml",
                 FileMode.Create, FileAccess.Write, FileShare.None);
            xmlFormat.Serialize(fStream, netIfs);
            fStream.Close();
            Console.WriteLine("Saved WMI1 in XML form"); 
            #endregion

            #region BinaryFormatter
            BinaryFormatter binaryFormat = new BinaryFormatter();
            fStream = new FileStream("WmiData.dat",
                 FileMode.Create, FileAccess.Write, FileShare.None);
            binaryFormat.Serialize(fStream, netIfs);
            fStream.Close();
            Console.WriteLine("Saved WMI1 object in binary form");

            // Read the WMI data from the binary stream.
            fStream = File.OpenRead("WmiData.dat");
            WMI1 netIfs2 =
                 (WMI1)binaryFormat.Deserialize(fStream);
            Console.WriteLine("Network interfaces : {0}", netIfs2.networkInterfaces);
            fStream.Close(); 
            #endregion
            
            #region SoapFormatter
            SoapFormatter soapFormat = new SoapFormatter();
            fStream = new FileStream("WmiData.soap",
                 FileMode.Create, FileAccess.Write, FileShare.None);
            soapFormat.Serialize(fStream, netIfs2);
            fStream.Close();
            Console.WriteLine("Saved WMI1 object in SOAP form"); 
            #endregion

			Console.ReadLine();
		}
	}
}
